Number of Pairs[二分查找函数]

2024-06-04 03:44

本文主要是介绍Number of Pairs[二分查找函数],希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Number of Pairs

题面翻译

【题目描述】

给出一个由整数组成的数组 a a a,求一对整数 ( i , j ) (i, j) (i,j) 1 ≤ i < j ≤ n 1 \le i < j \le n 1i<jn)满足 l ≤ a i + a j ≤ r l \le a_i + a_j \le r lai+ajr 的数量。

【输入格式】

在输入的第一行为一个整数 t t t 1 ≤ t ≤ 10 4 1 \le t \le {10}^4 1t104),为数据组数。

接下来对于每组数据,第一行为三个整数 n , l , r n,l,r n,l,r 1 ≤ n ≤ 2 × 10 5 1 \le n \le 2 \times {10}^5 1n2×105 1 ≤ l ≤ r ≤ 10 9 1 \le l \le r \le {10}^9 1lr109),为数组的长度和上文中的 l , r l, r l,r。第二行有 n n n 个整数 a 1 , a 2 , … , a n a_1, a_2, \ldots , a_n a1,a2,,an 1 ≤ a i ≤ 10 9 1 \le a_i \le {10}^9 1ai109)表示数组 a a a

保证对于所有组数据 ∑ n ≤ 2 × 10 5 \sum n \le 2 \times {10}^5 n2×105

【输出格式】

对于每组数据,输出满足条件的 ( i , j ) (i,j) (i,j) 组数。

题目描述

You are given an array $ a $ of $ n $ integers. Find the number of pairs $ (i, j) $ ( $ 1 \le i < j \le n $ ) where the sum of $ a_i + a_j $ is greater than or equal to $ l $ and less than or equal to $ r $ (that is, $ l \le a_i + a_j \le r $ ).

For example, if $ n = 3 $ , $ a = [5, 1, 2] $ , $ l = 4 $ and $ r = 7 $ , then two pairs are suitable:

  • $ i=1 $ and $ j=2 $ ( $ 4 \le 5 + 1 \le 7 $ );
  • $ i=1 $ and $ j=3 $ ( $ 4 \le 5 + 2 \le 7 $ ).

输入格式

The first line contains an integer $ t $ ( $ 1 \le t \le 10^4 $ ). Then $ t $ test cases follow.

The first line of each test case contains three integers $ n, l, r $ ( $ 1 \le n \le 2 \cdot 10^5 $ , $ 1 \le l \le r \le 10^9 $ ) — the length of the array and the limits on the sum in the pair.

The second line contains $ n $ integers $ a_1, a_2, \ldots, a_n $ ( $ 1 \le a_i \le 10^9 $ ).

It is guaranteed that the sum of $ n $ overall test cases does not exceed $ 2 \cdot 10^5 $ .

输出格式

For each test case, output a single integer — the number of index pairs $ (i, j) $ ( $ i < j $ ), such that $ l \le a_i + a_j \le r $ .

样例 #1

样例输入 #1

4
3 4 7
5 1 2
5 5 8
5 1 2 4 3
4 100 1000
1 1 1 1
5 9 13
2 5 5 1 1

样例输出 #1

2
7
0
1

思路分析:
从前面往后面扫一遍,每次都已当前位置为左边界,然后二分查找允许的边界,边界之差就是以当前点为左边界的所有情况符合条件的合集

函数介绍:

lower_bound://找到大于等于某一个数x的第一个数
upper_bound://找到大于某一个数x的第一个数
lower_bound(w+1+i,w+2+n,a-w[i]) - w;
//起始位置,终点位置,大于等于的数x,-w是为了明确返回坐标
#include<iostream>
#include<algorithm>
#include<cstring>
#include<string>
using namespace std;
int t, l, r,n,a,b;
int w[200005];
int main()
{cin >> t;while (t--){int num = 0;cin >> n >> a >> b;for (int i = 1; i <= n; i++) cin >> w[i];sort(w + 1, w + 1 + n);//排个序w[n + 1] = 1e9;//最为结束的标志for (int i = 1; i <= n; i++){l = lower_bound(w+1+i,w+2+n,a-w[i]) - w;//从二号位开始找别忘了,我们是为了找最小右边界r = upper_bound(w+1+i,w+2+n,b-w[i]) - w;//从二号位开始找别忘了,我们是为了找最大右边界if (r > l) num += r - l;//答案数+++}cout << num << endl;}return 0;
}

这篇关于Number of Pairs[二分查找函数]的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1028973

相关文章

hdu2241(二分+合并数组)

题意:判断是否存在a+b+c = x,a,b,c分别属于集合A,B,C 如果用暴力会超时,所以这里用到了数组合并,将b,c数组合并成d,d数组存的是b,c数组元素的和,然后对d数组进行二分就可以了 代码如下(附注释): #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<que

hdu2289(简单二分)

虽说是简单二分,但是我还是wa死了  题意:已知圆台的体积,求高度 首先要知道圆台体积怎么求:设上下底的半径分别为r1,r2,高为h,V = PI*(r1*r1+r1*r2+r2*r2)*h/3 然后以h进行二分 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#includ

hdu1171(母函数或多重背包)

题意:把物品分成两份,使得价值最接近 可以用背包,或者是母函数来解,母函数(1 + x^v+x^2v+.....+x^num*v)(1 + x^v+x^2v+.....+x^num*v)(1 + x^v+x^2v+.....+x^num*v) 其中指数为价值,每一项的数目为(该物品数+1)个 代码如下: #include<iostream>#include<algorithm>

usaco 1.2 Name That Number(数字字母转化)

巧妙的利用code[b[0]-'A'] 将字符ABC...Z转换为数字 需要注意的是重新开一个数组 c [ ] 存储字符串 应人为的在末尾附上 ‘ \ 0 ’ 详见代码: /*ID: who jayLANG: C++TASK: namenum*/#include<stdio.h>#include<string.h>int main(){FILE *fin = fopen (

poj 2976 分数规划二分贪心(部分对总体的贡献度) poj 3111

poj 2976: 题意: 在n场考试中,每场考试共有b题,答对的题目有a题。 允许去掉k场考试,求能达到的最高正确率是多少。 解析: 假设已知准确率为x,则每场考试对于准确率的贡献值为: a - b * x,将贡献值大的排序排在前面舍弃掉后k个。 然后二分x就行了。 代码: #include <iostream>#include <cstdio>#incl

poj 3104 二分答案

题意: n件湿度为num的衣服,每秒钟自己可以蒸发掉1个湿度。 然而如果使用了暖炉,每秒可以烧掉k个湿度,但不计算蒸发了。 现在问这么多的衣服,怎么烧事件最短。 解析: 二分答案咯。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <c

poj 3258 二分最小值最大

题意: 有一些石头排成一条线,第一个和最后一个不能去掉。 其余的共可以去掉m块,要使去掉后石头间距的最小值最大。 解析: 二分石头,最小值最大。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <c

poj 2594 二分图最大独立集

题意: 求一张图的最大独立集,这题不同的地方在于,间接相邻的点也可以有一条边,所以用floyd来把间接相邻的边也连起来。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <sta

poj 3692 二分图最大独立集

题意: 幼儿园里,有G个女生和B个男生。 他们中间有女生和女生认识,男生男生认识,也有男生和女生认识的。 现在要选出一些人,使得这里面的人都认识,问最多能选多少人。 解析: 反过来建边,将不认识的男生和女生相连,然后求一个二分图的最大独立集就行了。 下图很直观: 点击打开链接 原图: 现图: 、 代码: #pragma comment(

poj 2112 网络流+二分

题意: k台挤奶机,c头牛,每台挤奶机可以挤m头牛。 现在给出每只牛到挤奶机的距离矩阵,求最小化牛的最大路程。 解析: 最大值最小化,最小值最大化,用二分来做。 先求出两点之间的最短距离。 然后二分匹配牛到挤奶机的最大路程,匹配中的判断是在这个最大路程下,是否牛的数量达到c只。 如何求牛的数量呢,用网络流来做。 从源点到牛引一条容量为1的边,然后挤奶机到汇点引一条容量为m的边